/*

*/
#include <windows.h>
#include <stdio.h>
#include <math.h>
#include "glut.h"
#include "glui.h"

#define PI 3.14159265

int windowHeight;         // this is set by the glut reshape() callback function
int windowWidth;          // this is set by the glut reshape() callback function

int maxLevel = 14;
int level = 1;

#define sliderInit 0.5
float sliderValue1 = sliderInit;  // this is set by the glui slider() callback function
float sliderValue2 = sliderInit;  // this is set by the glui slider() callback function
float sliderValue3 = sliderInit;  // this is set by the glui slider() callback function

/* Prototypes for the GLUT callback functions */
void display( void );
void reshape(int, int);
void mouse(int, int, int, int);
void slider1(float);
void slider2(float);
void slider3(float);

int main(int argc, char** argv)
{
   int window;

   /* Standard GLUT initialization */
   glutInit(&argc,argv);
   glutInitDisplayMode (GLUT_DOUBLE | GLUT_RGB); /* default, not needed */
   glutInitWindowSize(600, 660);
   glutInitWindowPosition(100, 100);
   window = glutCreateWindow("Problem 1");
   glutDisplayFunc(display);
   glutReshapeFunc(reshape);
   glutMouseFunc(mouse);

   /* Initialize OpenGL state */
   /* attributes */
   glClearColor(1.0, 1.0, 1.0, 1.0); /* white background */

   // parent window, x, y, width, height, initial value, callback function
   gluiHorizontalSlider(window, 10,  0, -10, 20, sliderInit, slider1);
   gluiHorizontalSlider(window, 10, 20, -10, 20, sliderInit, slider2);
   gluiHorizontalSlider(window, 10, 40, -10, 20, sliderInit, slider3);

   /* Enter event loop */
   glutMainLoop();

   return 0;  /* we never get here */
}//main()


/* This function sends one instance of our model down the graphics pipeline. */
void model(int drawingLevel)
{
   /* Here are the primitives that make up our basic model. */
   glColor3f(0.0, 1.0, 0.0);  /* draw in green */
   glBegin(GL_QUADS);
     glVertex2f(0.0, 0.0);  // a square
     glVertex2f(1.0, 0.0);
     glVertex2f(1.0, 1.0);
     glVertex2f(0.0, 1.0);
   glEnd();

   if (drawingLevel == 1)
   {
      glColor3f(1.0, 1.0, 0.0); /* draw in yellow */
   }
   glBegin(GL_TRIANGLES);
     glVertex2f(0.0, 1.0);
     glVertex2f(1.0, 1.0);
     glVertex2f(0.5, 1.5);
   glEnd();

   glColor3f(0.0, 0.0, 0.0);  /* draw in black */
   glBegin(GL_LINE_LOOP);
     glVertex2f(0.0, 0.0);  // a square
     glVertex2f(1.0, 0.0);
     glVertex2f(1.0, 1.0);
     glVertex2f(0.0, 1.0);
   glEnd();

   glBegin(GL_LINE_LOOP);
     glVertex2f(0.0, 1.0);
     glVertex2f(1.0, 1.0);
     glVertex2f(0.5, 1.5);
   glEnd();

}//model()


/* recursive function that uses model() to draw the pythagorous tree */
void drawShape(int drawingLevel)
{


   model(drawingLevel);


}//drawShape()


/* The display() callback function */
void display( void )
{
   glClear(GL_COLOR_BUFFER_BIT); /* clear the window */

   // viewport
   glViewport(0, 0, windowWidth, windowHeight-60);

   /* set up viewing */
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   gluOrtho2D(-10.0, 10.0, -10.0, 10.0); /* viewing volume */

   /* draw the image for this viewport */
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();



   drawShape(1);

   glutSwapBuffers();  // glui needs double buffering!
}//display()


/* The reshape() callback function */
void reshape(int width, int height)
{
   windowWidth  = width;
   windowHeight = height;

   printf("We got a \"reshape(%d, %d)\" event\n", width, height);

   gluiReshape(width, height);
}//reshape()


/* The mouse() callback function */
void mouse(int button, int state, int x, int y)
{


   printf("We got a \"mouse(%d, %d, %d, %d)\" event\n", button, state, x, y);

   glutPostRedisplay();
}//mouse()


/* glui slider callback functions */
void slider1(float value)
{


   printf("We got a \"slider1(%f)\" event\n", value);

   glutPostRedisplay();
}//slider1()


void slider2(float value)
{


   printf("We got a \"slider2(%f)\" event\n", value);

   glutPostRedisplay();
}//slider2()


void slider3(float value)
{


   printf("We got a \"slider3(%f)\" event\n", value);

   glutPostRedisplay();
}//slider3()
